﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;
using Hydrobase;
using HydrobaseSDK;
using System.ServiceModel;
using System.ServiceModel.Web;
using System.Runtime.Serialization;
using System.IO;
using White_Tiger.ClientManagement;
using System.Web;


namespace White_Tiger
{
    [ServiceContract(CallbackContract = typeof(IClientManager))]
    public interface IWhiteTigerService
    {
        
       
        [OperationContract]
        [WebGet(UriTemplate = "Login/{username}/{password}")]

        bool Login(string username, string password);
        [OperationContract]
        [WebInvoke(UriTemplate = "CreateDatabase/{username}/{pass}/{dbname}")]
        void CreateDataBase(string username, string pass, string dbname);
        [OperationContract]
        [WebInvoke(UriTemplate = "CreateTable/{root}/{recordtag}/{username}/{pass}/{dbname}/{tablename}")]
        void CreateTable(string root,string recordtag,string username, string pass, string dbname, string tablename, string[] TableCells);
        [OperationContract]
        [WebGet(UriTemplate = "LoadTable/{recordtag}/{username}/{pass}/{dbname}/{table}")]
        string LoadTable( string recordtag, string username, string pass, string dbname, string table);
        [OperationContract]
        [WebInvoke(UriTemplate = "UpdateTable/{root}/{recordtag}/{username}/{pass}/{dbname}/{table}")]
        void UpdateTable(string root, string recordtag, string username, string pass, string dbname, string table, List<object[]> rows);
         [OperationContract]
         [WebInvoke(UriTemplate = "EncryptTable/{root}/{recordtag}/{username}/{dbname}/{table}/{pass}/{passphrase}")]
              void Encrypt(string root, string recordtag, string username, string dbname, string table, List<object[]> rows, string pass, string alg, string hashalg,string passphrase);
        [OperationContract]
        [WebGet(UriTemplate = "DecryptTable/{root}/{recordtag}/{username}/{dbname}/{table}/{pass}/{alg}/{hashalg}/{passphrase}")]
         string  Decrypt(string root, string recordtag, string username, string dbname, string table, string pass, string alg, string hashalg,string passphrase);
        [OperationContract]
        [WebInvoke(UriTemplate = "Backup/{username}/{dbname}/{table}/{pass}")]
        void Backup(string username, string dbname, string table, string pass);
        [OperationContract]
        [WebGet(UriTemplate = "GetVersion")]
      string GetVersion();
        [OperationContract]
        [WebGet(UriTemplate = "Find/{username}/{pass}/{dbname}/{table}/{cell}/{value}")]
        string Find(string username, string pass,string dbname, string table, string cell, string value);
      [OperationContract]

        DataTable FindTable(string username, string pass, string tablename);
     
     [OperationContract]
     [WebInvoke(UriTemplate = "AddRow/{root}/{recordtag}/{username}/{pass}/{dbname}/{table}")]
      void AddRow(string root, string recordtag, string username, string pass, string dbname, string table, object[] vals, bool autoupd);
   
      [OperationContract]

      [WebInvoke(UriTemplate = "AddRows/{root}/{recordtag}/{username}/{pass}/{dbname}/{table}")]
     void AddRows(string root, string recordtag, string username, string pass, string dbname, string table, List<object[]> vals, bool autoaupd);
        [OperationContract]

        [WebInvoke(UriTemplate = "RemoveRow/{username}/{pass}/{dbname}/{table}")]
        void RemoveRow(string username, string pass, string dbname, string table, object[] primkeys);
        [OperationContract]

        [WebGet(UriTemplate = "ListDataBases/{username}/{pass}")]
         string [] ListDatabases(string username,string pass);
        [OperationContract]

        [WebGet(UriTemplate = "ListTables/{username}/{pass}/{dbname}")]
        string[] ListTables(string username, string pass, string dbname);
        [OperationContract]

        [WebInvoke(UriTemplate = "AddColumns/{root}/{recordtag}/{username}/{pass}/{dbname}/{table}")]
        void  AddColumns(string root, string recordtag, string username, string pass, string dbname, string table, object[] cols, bool autoupd);
        [OperationContract]

        [WebGet(UriTemplate = "IsTableEncrypted/{username}/{pass}/{dbname}/{tablename}")]
        bool IsTableEncrypted(string username, string pass, string dbname, string tablename);
        [OperationContract]

        [WebInvoke(UriTemplate = "CloseTable/{username}/{pass}/{dbname}/{tablename}")]
        void CloseTable(string username, string pass, string dbname, string tablename);
        [WebGet(UriTemplate="GetColumns/{username}/{pass}/{dbname}/{tablename}")]
      string[] GetColumns(string username, string pass, string dbname, string tablename);
    
    }
    }


        
