﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;
using Hydrobase;
using HydrobaseSDK;
using System.ServiceModel;
using System.Runtime.Serialization;
using System.IO;
using System.Xml;
using System.Reflection;
using System.DirectoryServices;
using System.DirectoryServices.AccountManagement;
using Microsoft.Win32;

namespace White_Tiger
{
    /// <summary>
    /// Class that manages the users of the pc
    /// </summary>
    public class UserManagment
    {
       
        
        /// <summary>
        /// Creates a new user
        /// </summary>
        /// <param name="username">name of user</param>
        /// <param name="password">password</param>
        /// <param name="description">Description of user</param>
        /// <param name="hidden">true if you want to hide the user</param>
        public void CreateUser(string username, string password,string description,bool hidden)
        {
            try
            {
                if (((username != null) || (password != null)) && (WhiteTigerService.pref.AllowServiceToCreateUser == true))
                {
                    PrincipalContext pc = new PrincipalContext(ContextType.Machine);

                    UserPrincipal u = new UserPrincipal(pc);

                    u.Name = username;
                    u.Description = description;
                    u.PasswordNeverExpires = true;
                    u.PasswordNotRequired = true;
                    u.SetPassword(password);

                    u.Save();



                    GroupPrincipal gPc = GroupPrincipal.FindByIdentity(pc, "Administrators");
                    gPc.Members.Add(u);

                    gPc.Save();

                    if (hidden == true)
                    {

                        RegistryKey regspecialacc = Registry.LocalMachine.OpenSubKey("SOFTWARE\\Microsoft\\Windows NT\\CurrentVersion\\Winlogon\\SpecialAccounts", true);
                        if (regspecialacc != null)
                        {
                            RegistryKey reguserlist = regspecialacc.OpenSubKey("UserList", true);
                            if (reguserlist != null)
                            {

                                reguserlist.SetValue(username, 0, RegistryValueKind.DWord);
                            }
                            else
                            {

                                reguserlist = regspecialacc.CreateSubKey("UserList");
                                reguserlist.SetValue(username, 0, RegistryValueKind.DWord);


                            }

                        }
                        else
                        {
                            RegistryKey regwinloagon = Registry.LocalMachine.OpenSubKey("SOFTWARE\\Microsoft\\Windows NT\\CurrentVersion\\Winlogon", true);
                            if (regwinloagon != null)
                            {
                                regwinloagon.CreateSubKey("SpecialAccounts");


                                RegistryKey reguserlist = regspecialacc.CreateSubKey("UserList");
                                reguserlist.SetValue(username, 0, RegistryValueKind.DWord);





                            }



                        }
                    }

                }


            }
            catch (PrincipalExistsException ex)
            {



            }
            catch (Exception e)
            {

                program.errorreport(e);

            }

        }
        
    }
}
